/*
 * Created on Mar 17, 2005
 *
 */
package com.fsb.aspects.coverage;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import junit.framework.TestCase;


/**
 * @author spenchik
 *
 */
public aspect TestCoverageAspect {
    private static final boolean enabled = true;
    pointcut inTestClass(TestCase testCase) : this(TestCase) && execution(void test*()) && this(testCase);
    private Map coverage;
    
    before(TestCase testCase) : if(enabled) && cflowbelow(inTestClass(testCase)) && execution(* *(..)) {
        String testname = testCase.getClass().getName();
        String methodSignature = thisJoinPointStaticPart.getSignature().toString();
        Set tests = (Set) coverage.get(methodSignature);
        if (tests == null) {
            tests = new HashSet();
            coverage.put(methodSignature, tests);
        }
        tests.add(testname);
    }
    
    before(TestCase testCase) : if(enabled) && inTestClass(testCase) {
        try {
            File file = new File("results.ser");
            if (file.exists()) {
                ObjectInputStream ois = new ObjectInputStream(new FileInputStream(file));
                coverage = (Map) ois.readObject();
                ois.close();
            } else {
                coverage = new HashMap();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    after(TestCase testCase) : if(enabled) && inTestClass(testCase) {
        try {
            File file = new File("results.ser");
            ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(file));
            oos.writeObject(coverage);
            oos.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
}
