package com.cachingapp.cache;


/**
 * This interface defines the method to implement the data access logic for a cached object.
 *
 * @version 1.0
 * @author Srini Penchikala
 * @since 10/03/2003
 */
public interface ICacheLoader {

	/**
 	 * Override this method to implement data access logic (preferably using a Data Access
 	 * Object pattern) to get the data (or objects) that need to be cached. CacheManager calls
 	 * this method to populate the cache when a cached object is expired.
    * @param cacheKey Key for the cache object
    * @param regionName Name of cache region where object needs to be cached
    * @return cached object
    * @throws CachingException
	 */
	public Object loadCacheObject(Object cacheKey, String regionName) throws CachingException;

}
// End of ICacheLoader.java
